-- name:\\#F78343\\Helicopter \\#727272\\ Lifestyle \\#ffffff\\v2
-- description: Become a helicopter!!! Y to start Flight, A to propell up, X to throttle forwards, Z to hover!

ACT_HELICOPTER = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_ATTACKING | ACT_FLAG_WATER_OR_TEXT)

local takeoff = audio_sample_load("takeoff.ogg")

local helicopterhelicopter = audio_sample_load("helicopterhelicopter.ogg")

gStateExtras = {}
for i = 0, (MAX_PLAYERS - 1) do
    gStateExtras[i] = {}
    local m = gMarioStates[i]
    local e = gStateExtras[i]
    e.rotAngle = 0
end

local s16 = function(x)

    x = (math.floor(x) & 0xFFFF)

    if x >= 32768 then return x - 65536 end
    return x
end

local function act_helicopter(m)
  local e = gStateExtras[m.playerIndex]
  
  local intendedYawbutcoolig = s16(m.intendedYaw - m.faceAngle.y)

    local spinDirFactor = 1 
    if m.actionState == 1 then spinDirFactor = -1 end
  
  if m.actionTimer == 0 then
    m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
    m.squishTimer = 2
end

  --common_air_action_step(m, ACT_TWIRL_LAND, CHAR_ANIM_FLY_FROM_CANNON, AIR_STEP_NONE)
  
  step = perform_air_step(m, 0)
  
  if step == AIR_STEP_HIT_WALL and m.flags & MARIO_VANISH_CAP == 0 and m.invincTimer < 1 then
    spawn_non_sync_object(id_bhvExplosion, E_MODEL_EXPLOSION, m.pos.x, m.pos.y, m.pos.z, nil)
  elseif step == AIR_STEP_LANDED then
    set_mario_action(m, ACT_TWIRL_LAND, 0)
  end
  
  if m.controller.stickMag ~= 0 then 
    
      if m.controller.buttonDown & X_BUTTON ~= 0 then
        m.particleFlags = PARTICLE_SPARKLES
     mario_set_forward_vel(m, approach_f32(m.forwardVel, 55, 2.5, 2.5))
     else
      mario_set_forward_vel(m, approach_f32(m.forwardVel, 30, 2.5, 1))
      end
      
      else
        mario_set_forward_vel(m, approach_f32(m.forwardVel, 0, 1, 1))
      end
  
vec3f_set(m.marioBodyState.headAngle, 0x3000, 0, 0)
set_mario_animation(m, CHAR_ANIM_FLY_FROM_CANNON)
set_anim_to_frame(m, 7)
vec3f_set(m.marioBodyState.headPos, 0, 10, 0)

if m.controller.buttonDown & A_BUTTON ~= 0 then
  
  m.vel.y = approach_f32(m.vel.y, 35, 5.5, 2.5)
   
elseif m.controller.buttonDown & B_BUTTON ~= 0 then
  m.vel.y = approach_f32(m.vel.y, -35, 5, 2.5)
elseif
   m.controller.buttonDown & Z_TRIG ~= 0 then
  m.vel.y = approach_f32(m.vel.y, 0, 10, 10)
  else
  if m.vel.y < -15 then
    m.vel.y = -15
  end
end
  
  if m.forwardVel > 35 then
  e.rotAngle = e.rotAngle + 0x15*(m.forwardVel*15)
  else
    e.rotAngle = e.rotAngle + 0x2000
    end
    if e.rotAngle >  0x10000 then 
      e.rotAngle = e.rotAngle - 0x10000
    play_sound(SOUND_ACTION_TWIRL, m.pos)
   m.particleFlags = PARTICLE_DUST
    end
    
    m.marioObj.header.gfx.angle.x = ((m.forwardVel/35)*0x1000)-0x4000
  
  m.marioObj.header.gfx.angle.z = m.marioObj.header.gfx.angle.z + e.rotAngle
  
  m.faceAngle.y = m.intendedYaw - approach_s32(intendedYawbutcoolig, 0, 0x1500, 0x1500)
  
  m.actionTimer = m.actionTimer + 1
  return 
  end

local function mario_update(m)
  if m.playerIndex == 0 then
    if m.controller.buttonPressed & Y_BUTTON ~= 0 and ((m.action & ACT_GROUP_MASK) ~= ACT_GROUP_SUBMERGED and (m.action & ACT_GROUP_MASK) ~= ACT_GROUP_CUTSCENE and (m.action & ACT_GROUP_MASK) ~= ACT_GROUP_AUTOMATIC) and m.action ~= ACT_HELICOPTER and m.health > 0xff then
      m.vel.y = m.vel.y + 50
        set_mario_action(m, ACT_HELICOPTER, 0)
        play_character_sound(m, CHAR_SOUND_HAHA)
   audio_sample_play(takeoff, m.pos, 0.25)
   if m.heldObj ~= nil then
     audio_sample_play(helicopterhelicopter, m.pos, 0.5)
     end
    end
    
  end
  end

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_mario_action(ACT_HELICOPTER, act_helicopter)